clear
% Solve x=g(x) for g(x)=sqrt(x+2)
g = @(x) sqrt(x+2);


% no Anderson
x=1.9;
for i=1:50
    xold = x;
    x = g(x);
    w(i)= norm(x-xold);
    if w(i)<1e-8
        break
    end
end

semilogy(w,'kx-')
hold on

% with m=1 Anderson
x=1.9;
allxtilde = x;
allx=x;

% step 1
xtilde = g(x);
w(1)= norm(x-xtilde);
x=xtilde;
allxtilde(:,2)=xtilde;
allx(:,2)=xtilde;

% step k
for j=3:50
    xtilde = g(x);
    allxtilde(:,j)=xtilde;
    wAA(j-1)= norm(xtilde-x);
    if wAA(j-1)<1e-8
        break
    end
    
    % AA step (define function we want to miminize, then call fminsearch
    f = @(a) norm(a * (allxtilde(:,end) - allx(:,end)) + (1-a)*(allxtilde(:,end-1)-allx(:,end-1)) );
    [alpha,fval] = fminsearch(f,1);
        
    x = alpha*allxtilde(:,end) + (1-alpha)*allxtilde(:,end-1);
    allx(:,j)=x;
end

semilogy(wAA,'bo-')
xlabel('k','FontSize',20)
ylabel('Residual','FontSize',20)
set(gca,'FontSize',20)
legend('Usual fixed point','AA m=1')