



% (pre)calculate basis function values and store them
basisValues = zeros(6,7,size(elnode,1));
gradBasisValues = zeros(6,2,7,size(elnode,1));
for triag_no=1:size(elnode,1)
    % Description of triangle.
    cotri(1:3,1) = nodeco(elnode(triag_no, 1:3), 1) ;
    cotri(1:3,2) = nodeco(elnode(triag_no, 1:3), 2) ;

    Jmat = [(cotri(2,1) - cotri(1,1)), (cotri(3,1) - cotri(1,1)) ; ...
        (cotri(2,2) - cotri(1,2)) , (cotri(3,2) - cotri(1,2)) ] ;
    detJ = abs(Jmat(1,1)*Jmat(2,2) - Jmat(1,2)*Jmat(2,1));
    JInv = inv(Jmat) ;

    detJglobal(triag_no)=detJ;

    % Evaluation of quadrature points and quadrature weights.
    [quad_pts, quad_wghts] = feval('quad_75') ;
    nqpts = size(quad_pts,1) ;

    % Adjust points and weights to account for size of true triangle.
    xy_pts = ( Jmat * quad_pts.' ).' ;
    xy_pts(:,1) = cotri(1,1) + xy_pts(:,1) ;
    xy_pts(:,2) = cotri(1,2) + xy_pts(:,2) ;
    quad_wghts = detJ * quad_wghts ;

    quad_wghtsglobal(triag_no,:)=quad_wghts;

    %  Evaluate Basis Functions and their Gradients at quad. points.
    [ten1a, Gradten1a] = feval(vel_bas_type, quad_pts) ;
    basisValues(:,:,triag_no)=ten1a;

    for iq = 1:nqpts
        Gradtrue1(:,:,iq) = Gradten1a(:,:,iq) * JInv ;
    end

    gradBasisValues(:,:,:,triag_no)=Gradtrue1;

 end