% nodeco holds node coordinates
% elnode row j holds the nodes in element (triangle j)
[nodeco, elnode, bdynde] = FFEM2ErvGrd2('SquareMeshU32.msh') ;

% create P2 by putting midedges on triangle edges
[nodeco, elnode, bdynde, bdyedge, nVert, nedge] =  midEDGEgen(nodeco, elnode, bdynde) ;


% boundary for unit cube domain
bdynde=[];
 for i=1:size(nodeco,1)
     x=nodeco(i,1);
     y=nodeco(i,2);
     if abs( x*(1-x)*y*(1-y) )<1e-10
         bdynde=[bdynde;i];
     end
 end

bdrysize = 2*size(bdynde,1);
bdrydof=[];
for ii=1:bdrysize/2
    bdrydof = [bdrydof; 2*bdynde(ii,1)-1; 2*bdynde(ii,1)];
end

% pressure init
GlobalP = zeros(nVert,1);
GlobalV = zeros((nVert + nedge)*2, 1) ;
PastV = [GlobalV];

NVU = size(GlobalV,1) 
NPU = size(GlobalP,1) 

% put velocity at (1,0) at top of cavity
  for i=1:size(bdynde,1)
     x=nodeco(bdynde(i),1);
     y=nodeco(bdynde(i),2);
     if y>.9999
         GlobalV(2*bdynde(i)-1)=1;
     end
  end