% NSE with Picard iteration for driven cavity
clear


%%%%%%%%%%%%%%%%%%%%%% Global Variables %%%%%%%%%%%%%%%%%%%
global nodeco  elnode  bdynde  bdyedge  nVert  nedge GlobalVnew
global GlobalV  GlobalP  nu vel_bas_type  pre_bas_type problem sig
global  t AllV dt GlobalT GlobalC AllT AllC bdyndeTC GlobalV2 GlobalP2
global Sdim NVU NPU dir StiffnessMatrix PressureMatrix Bouyancy basisValues gradBasisValues v p Ri kappa bdrydof bdrydofT


% P2 velocity, P1 pressure
vel_bas_type = 'CtsQuad' ;  
pre_bas_type = 'CtsLin' ;  

Re = 3000;
nu = 1/Re;

InitMeshAndBoundary;

InitBasisFunctions;

% create the matrices that will be used multiple times
createConstantMatrices5;
    


% do the Picard iteration
for jj=1:200

    PastV = GlobalV;
    number1=0;
    
    % assemble the matrix and rhs vector using finite element method
    AssembleNSEPicardMatrix;

    % Do the linear solve, extract velocity and pressure
    x = Acoeff \ RHSvec;
    GlobalV = x(1:NVU);
    GlobalP = x(NVU+1:end);
        
    % Calculate residual in H1 norm
    diff = GlobalV - PastV;
    H1diff = sqrt( diff' * (StiffnessMatrix * diff) );
    display([num2str(jj) '  ' num2str(H1diff)])
        
    PicardH1diff(jj) = H1diff;
    
    % if small residual, then stop
    if H1diff<1e-8
            break
    end


end
    
plotCavity
