function [x,l] = PowerMethod(A, x0, tolerance)
% Compute eigenvector x and eigenvalue l of the matrix
% A using the Power method with initial guess x0 and given
% tolerance

x = x0;

l = x' * (A*x) / (x'*x);
lold = l+1;

itcount=0;

while abs(l - lold)>tolerance
    
    itcount=itcount+1;
    if itcount>100
        error('iterations exceeded 100');
    end
    
    y = A*x;
    x = y / norm(y,inf);
    
    lold = l;
    l = x' * (A*x) / (x'*x);
end

end
